import * as React from 'react';
import { IMarkerGroup } from './type';
export interface ITextareaMarkdownEditor {
    id?: string;
    textareaId?: string;
    className?: string;
    viewerClassName?: string;
    viewerStyle?: object;
    placeholder?: string;
    style?: object;
    textareaStyle?: object;
    rows?: number;
    maxLength?: number;
    defaultValue?: string;
    value?: string;
    autoFocus?: boolean;
    readOnly?: boolean;
    onChange?: (value: string) => {};
    onKeyDown?: (event: React.KeyboardEvent) => {};
    onKeyPress?: (event: React.KeyboardEvent) => {};
    doParse: (text: string) => string;
    language?: string;
    markers?: IMarkerGroup[];
    onCopy?: (event: React.ClipboardEvent) => void;
    onCopyCapture?: (event: React.ClipboardEvent) => void;
    onPaste?: (event: React.ClipboardEvent) => void;
    onPasteCapture?: (event: React.ClipboardEvent) => void;
}
interface ITextareaMarkdownEditorState {
    edit: boolean;
    lineMarkers: string[];
    value?: string;
}
declare class TextareaMarkdownEditor extends React.Component<ITextareaMarkdownEditor, ITextareaMarkdownEditorState> {
    static defaultProps: {
        language: string;
        readOnly: boolean;
        rows: number;
    };
    private textareaRef;
    constructor(props: ITextareaMarkdownEditor);
    focus(): void;
    append(content: string): void;
    mark(prefix: string, suffix: string, defaultText: string, multipleLine?: boolean): void;
    markLine(marker: string): void;
    registerLineMarker(marker: string): void;
    markTemplate(template: string, multipleLine?: boolean): void;
    render(): JSX.Element;
    private toggleEdit;
    private onChange;
}
export default TextareaMarkdownEditor;
